'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _constants = require('../data/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TextStyleApplier = function () {
  function TextStyleApplier() {
    _classCallCheck(this, TextStyleApplier);
  }

  _createClass(TextStyleApplier, null, [{
    key: 'applyStyle',
    value: function applyStyle(value, style) {
      var styledValue = value;

      if (style.color) {
        styledValue = TextStyleApplier.applyTextColor(styledValue, style.color);
      }

      if (style.backgroundColor) {
        styledValue = TextStyleApplier.applyBackgroundColor(styledValue, style.backgroundColor);
      }

      if (style.format) {
        styledValue = TextStyleApplier.applyTextFormat(styledValue, style.format);
      }

      return styledValue;
    }
  }, {
    key: 'applyTextColor',
    value: function applyTextColor(value, textColor) {
      switch (textColor) {
        case _constants.TextColor.BLACK:
          return _colors2.default.black(value);
        case _constants.TextColor.RED:
          return _colors2.default.red(value);
        case _constants.TextColor.GREEN:
          return _colors2.default.green(value);
        case _constants.TextColor.YELLOW:
          return _colors2.default.yellow(value);
        case _constants.TextColor.BLUE:
          return _colors2.default.blue(value);
        case _constants.TextColor.MAGENTA:
          return _colors2.default.magenta(value);
        case _constants.TextColor.CYAN:
          return _colors2.default.cyan(value);
        case _constants.TextColor.WHITE:
          return _colors2.default.white(value);
        case _constants.TextColor.GRAY:
          return _colors2.default.gray(value);
        case _constants.TextColor.GREY:
          return _colors2.default.grey(value);
        default:
          throw new Error('Unknown text color: ' + textColor);
      }
    }
  }, {
    key: 'applyBackgroundColor',
    value: function applyBackgroundColor(value, backgroundColor) {
      switch (backgroundColor) {
        case _constants.BackgroundColor.BLACK:
          return _colors2.default.bgBlack(value);
        case _constants.BackgroundColor.RED:
          return _colors2.default.bgRed(value);
        case _constants.BackgroundColor.GREEN:
          return _colors2.default.bgGreen(value);
        case _constants.BackgroundColor.YELLOW:
          return _colors2.default.bgYellow(value);
        case _constants.BackgroundColor.BLUE:
          return _colors2.default.bgBlue(value);
        case _constants.BackgroundColor.MAGENTA:
          return _colors2.default.bgMagenta(value);
        case _constants.BackgroundColor.CYAN:
          return _colors2.default.bgCyan(value);
        case _constants.BackgroundColor.WHITE:
          return _colors2.default.bgWhite(value);
        default:
          throw new Error('Unknown background color: ' + backgroundColor);
      }
    }
  }, {
    key: 'applyTextFormat',
    value: function applyTextFormat(value, textFormat) {
      switch (textFormat) {
        case _constants.TextFormat.RESET:
          return _colors2.default.reset(value);
        case _constants.TextFormat.BOLD:
          return _colors2.default.bold(value);
        case _constants.TextFormat.DIM:
          return _colors2.default.dim(value);
        case _constants.TextFormat.ITALIC:
          return _colors2.default.italic(value);
        case _constants.TextFormat.UNDERLINE:
          return _colors2.default.underline(value);
        case _constants.TextFormat.INVERSE:
          return _colors2.default.inverse(value);
        case _constants.TextFormat.HIDDEN:
          return _colors2.default.hidden(value);
        case _constants.TextFormat.STRIKETHROUGH:
          return _colors2.default.strikethrough(value);
        default:
          throw new Error('Unknown text format: ' + textFormat);
      }
    }
  }]);

  return TextStyleApplier;
}();

exports.default = TextStyleApplier;