'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _styledRange = require('./data/styledRange');

var _styledRange2 = _interopRequireDefault(_styledRange);

var _textStyle = require('./data/textStyle');

var _textStyle2 = _interopRequireDefault(_textStyle);

var _textStyleApplier = require('./services/textStyleApplier');

var _textStyleApplier2 = _interopRequireDefault(_textStyleApplier);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TextStyler = function () {
  function TextStyler() {
    _classCallCheck(this, TextStyler);
  }

  _createClass(TextStyler, null, [{
    key: 'style',
    value: function style(text, styledSubstrings) {
      var characterStyles = TextStyler.getCharacterStyles(styledSubstrings);
      return TextStyler.applyStyles(text, characterStyles);
    }
  }, {
    key: 'getCharacterStyles',
    value: function getCharacterStyles(styledSubstrings) {
      var characterStyles = {};
      styledSubstrings.forEach(function (styledSubstring) {
        if (styledSubstring instanceof _styledRange2.default) {
          TextStyler.validateRange(styledSubstring);

          for (var i = styledSubstring.range.start; i <= styledSubstring.range.end; i += 1) {
            if (i in characterStyles) {
              characterStyles[i] = _textStyle2.default.mergeStyles(characterStyles[i], styledSubstring.style);
            } else {
              characterStyles[i] = styledSubstring.style;
            }
          }
        } else {
          throw new Error('Unable to apply style for ' + styledSubstring);
        }
      });
      return characterStyles;
    }
  }, {
    key: 'applyStyles',
    value: function applyStyles(text, characterStyles) {
      var styledText = '';
      for (var i = 0; i < text.length; i += 1) {
        var currentCharacter = text[i];
        var styledCharacter = currentCharacter;
        if (i in characterStyles) {
          var style = characterStyles[i];
          styledCharacter = _textStyleApplier2.default.applyStyle(currentCharacter, style);
        }
        styledText = '' + styledText + styledCharacter;
      }
      return styledText;
    }
  }, {
    key: 'validateRange',
    value: function validateRange(range) {
      if (range.start < 0) {
        throw new Error('start value: ' + range.start + ' cannot be less than 0');
      }

      if (range.end < 0) {
        throw new Error('end value: ' + range.end + ' cannot be less than 0');
      }

      if (range.start > range.end) {
        throw new Error('start value: ' + range.start + ' cannot be greater than the end value: ' + range.end);
      }
    }
  }]);

  return TextStyler;
}();

exports.default = TextStyler;